using System.Numerics;

using Microsoft.Graphics.Canvas;
using Microsoft.Graphics.Canvas.Geometry;
using Microsoft.Graphics.Canvas.Effects;
using Microsoft.Graphics.Canvas.UI.Xaml;
using Microsoft.UI;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.canvasControl.Draw += canvasControl_Draw;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region ĵ Ʈ ׸ - canvasControl_Draw(canvasControl, e)

    /// <summary>
    /// ĵ Ʈ ׸
    /// </summary>
    /// <param name="canvasControl">ĵ Ʈ</param>
    /// <param name="e">̺Ʈ </param>
    private void canvasControl_Draw(CanvasControl canvasControl, CanvasDrawEventArgs e)
    {
        using(CanvasDrawingSession canvasDrawingSession1 = e.DrawingSession)
        {
            CanvasGeometry canvasGeometry1 = CanvasGeometry.CreatePolygon
            (
                canvasControl,
                [
                    new Vector2( 10, 110),
                    new Vector2( 60,  10),
                    new Vector2(110, 110),
                    new Vector2(105, 110),
                    new Vector2( 60,  18),
                    new Vector2( 15, 110),
                    new Vector2( 10, 110)
                ]
            );

            CanvasCommandList canvasCommandList1 = new CanvasCommandList(canvasControl);

            using(CanvasDrawingSession CanvasDrawingSession2 = canvasCommandList1.CreateDrawingSession())
            {
                CanvasDrawingSession2.DrawGeometry(canvasGeometry1, Colors.DarkRed, 2);
                CanvasDrawingSession2.FillGeometry(canvasGeometry1, Colors.Red);
            }

            GaussianBlurEffect gaussianBlurEffect1 = new GaussianBlurEffect
            {
                Source     = canvasCommandList1,
                BlurAmount = 10f
            };

            canvasDrawingSession1.DrawImage(gaussianBlurEffect1);

            canvasDrawingSession1.DrawGeometry(canvasGeometry1, Colors.DarkRed, 2);
            canvasDrawingSession1.FillGeometry(canvasGeometry1, Colors.Red);

            CanvasGeometry canvasGeometry2 = CanvasGeometry.CreatePolygon
            (
                canvasControl,
                [
                    new Vector2(160, 105),
                    new Vector2(260, 105),
                    new Vector2(260,  10),
                    new Vector2(265,  10),
                    new Vector2(265, 110),
                    new Vector2(160, 110),
                    new Vector2(160, 105)
                ]
            );

            CanvasCommandList canvasCommandList2 = new CanvasCommandList(canvasControl);

            using(CanvasDrawingSession canvasDrawingSession3 = canvasCommandList2.CreateDrawingSession())
            {
                canvasDrawingSession3.DrawGeometry(canvasGeometry2, Colors.DarkGreen, 2);
                canvasDrawingSession3.FillGeometry(canvasGeometry2, Colors.Green);
            }

            GaussianBlurEffect gaussianBlurEffect2 = new GaussianBlurEffect
            {
                Source     = canvasCommandList2,
                BlurAmount = 10f
            };

            canvasDrawingSession1.DrawImage(gaussianBlurEffect2);

            canvasDrawingSession1.DrawGeometry(canvasGeometry2, Colors.DarkGreen, 2);
            canvasDrawingSession1.FillGeometry(canvasGeometry2, Colors.Green);
        }
    }

    #endregion
}